#include <stdio.h>
#include <stdlib.h>
#include <string.h>



static unsigned int get_word(unsigned char *p){
	return (p[0] | (p[1] << 8));
}

static unsigned long get_dword(unsigned char *p){
	return (p[0] | (p[1] << 8) | (p[2] << 16) | (p[3] << 24));
}



int main(int argc, char *argv[]){
	char *src;
	long size;

	if(2 > argc){
		printf("fl1_div.exe [infile]\n");
		exit(0);
	}

	{
		FILE *fp;
		fp = fopen(argv[1], "rb");
		if(NULL == fp){
			exit(1);
		}
		fseek(fp, 0, SEEK_END);
		size = ftell(fp);
		src = malloc(size);
		if(NULL == src){
			fclose(fp);
			exit(1);
		}
		fseek(fp, 0, SEEK_SET);
		fread(src, 1, size, fp);
		fclose(fp);
	}

	if(0 != memcmp(src, "FL1.0",5)){
		free(src);
		exit(1);
	}

	{
		FILE *fp;
		long idx_ofs, data_ofs;
		int num;
		long t_size;
		char t_name[16];

		data_ofs = (get_word(src + 6) + 16);
		num = get_word(src + 8);
		idx_ofs = get_dword(src + 10);

		while(num > 0){
			memset(t_name, 0, sizeof(t_name));
			memcpy(t_name, (src + idx_ofs), 12);
			t_size = get_dword(src + idx_ofs + 12);
			fp = fopen(t_name, "wb");
			fwrite((src + data_ofs), 1, t_size, fp);
			fclose(fp);
			data_ofs += t_size;
			idx_ofs += 16;
			num -= 1;
		}
	}

	free(src);

	exit(0);
}
